' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
'   Used to determine the current users
'   Date format
' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
Private Declare Function GetSystemDefaultLCID Lib "kernel32" () As Long
Private Declare Function GetLocaleInfo Lib "kernel32" Alias "GetLocaleInfoA" _
    (ByVal Locale As Long, ByVal LCType As Long, ByVal lpLCData As String, _
    ByVal cchData As Long) As Long

Private Const LOCALE_SSHORTDATE     As Long = &H1F
Private Const DATE_SHORTDATE        As Long = &H1
Private Const LOCALE_SDATE          As Long = &H1D


' #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
'   LocaleCorrectDate: Takes the Month, Day and
'       year of a day a builds a date string
'       that is correct to the current systems
'       date format
'
'       Parameters: Month, Day, Year
'       Returns: A date
' #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
Private Function LocaleCorrectDate(sMonth As String, sDay As String, sYear As String) As String
    
    Dim lngLCID         As Long
    Dim strDateFormat   As String
    Dim strDateSep      As String
    
    Dim strDate         As String
    
    Const cstrLocation  As String = "frmMain!LocaleCorrectDate"
    
    On Error GoTo LocaleCorrectDate_Error

    'get the user's Locale ID
    lngLCID = GetSystemDefaultLCID()
   
    'Show the user's Long date format string
    strDateFormat = GetUserLocaleInfo(lngLCID, LOCALE_SSHORTDATE)
    strDateSep = GetUserLocaleInfo(lngLCID, LOCALE_SDATE)
    
    ' 1st Portion
    Select Case UCase$(Left$(strDateFormat, 1))
        Case "Y"
            strDate = Trim$(sYear) & strDateSep
        Case "M"
            strDate = Trim$(sMonth) & strDateSep
        Case "D"
            strDate = Trim$(sDay) & strDateSep
    End Select
    
    ' 2nd Portion
    Select Case UCase$(Mid$(strDateFormat, InStr(strDateFormat, strDateSep) + 1, 1))
        Case "Y"
            strDate = strDate & Trim$(sYear) & strDateSep
        Case "M"
            strDate = strDate & Trim$(sMonth) & strDateSep
        Case "D"
            strDate = strDate & Trim$(sDay) & strDateSep
    End Select
    
    ' 3rd Portion
    Select Case UCase$(Right$(strDateFormat, 1))
        Case "Y"
            strDate = strDate & Trim$(sYear)
        Case "M"
            strDate = strDate & Trim$(sMonth)
        Case "D"
            strDate = strDate & Trim$(sDay)
    End Select
    
    LocaleCorrectDate = strDate
    
LocaleCorrectDate_Exit:
    On Error GoTo 0
    Exit Function
    
LocaleCorrectDate_Error:
    ShowError cstrLocation
    Resume LocaleCorrectDate_Exit
    
End Function


